import Control.Concurrent (forkIO, threadDelay)
import Control.Monad (forever)

main = do
	forkIO(forever (waitAndOutput 2 "Second thread calling in!"))
	forever (waitAndOutput 1 "Hi from the main thread")
	where
		waitAndOutput d t = do
			threadDelay(d * 1000000)
			putStrLn(t)