import Control.Concurrent
import Control.Monad (forever)

main = do
	mvar <- newMVar 1
	forkIO(forever (secondThread mvar))
	forever (waitAndOutput mvar)
	where
		waitAndOutput mv = do
			threadDelay(500000)
			val <- readMVar mv
			putStrLn("Current value: " ++ show val)
			
		secondThread mv = do
			threadDelay(2000000)
			currentval <- takeMVar mv
			putMVar mv (currentval + 1)
			putStrLn("Second thread incremented shared value")
			