import Debug.Trace (trace)

debug s x = trace (s ++ " " ++ (show x)) x

-- We are familiar with lazy evaluation in list cases
squares = [s | x <- [1..], let s = x * x]
odds = [x | x <- [1..], odd x]
squares' = [s | x <- [1..], let s = debug "returning square" (x * x)]
odds' = [x | x <- [1..], debug "checking number for oddity" (odd x)]

-- okay, today the world is round
isWorldRound = True
-- isWorldRound = debug "world round?" False 

complicatedCalculation x = 
	-- imagine this to be the type of really
	-- complicated calculation that runs for a thousand
	-- years and then return 42
 	let y = x * 2
 	in 42
-- 	let y = debug "y is" x * 2
-- 	in debug "calculation returns" 42

main = do
	let importantResult = complicatedCalculation 99
	if (not isWorldRound) then putStrLn (show importantResult)
		else putStrLn "World is round again, sorry"
